---
title: XMLHttpRequest.responseType
slug: Web/API/XMLHttpRequest/responseType
tags:
  - AJAX
  - API
  - HTTP
  - HTTP Response
  - HTTP Response Type
  - Property
  - Reference
  - Response
  - XHR
  - XMLHttpRequest
  - responseType
---
<div>{{APIRef('XMLHttpRequest')}}</div>

<p><span class="seoSummary">The {{domxref("XMLHttpRequest")}} property <strong><code>responseType</code></strong> is an enumerated string value specifying the type of data contained in the response.</span> It also lets the author change the response type. If an empty string is set as the value of <code>responseType</code>, the default value of <code>text</code> is used.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <var>type</var> = <var>XMLHttpRequest</var>.responseType;

<var>XMLHttpRequest</var>.responseType = <var>type</var>;</pre>

<h3 id="Value">Value</h3>

<p>A string taken from the {{domxref("XMLHttpRequestResponseType")}} enum which specifies what type of data the response contains.</p>

<div class="note">
<p>When setting <code>responseType</code> to a particular value, the author should make sure that the server is actually sending a response compatible with that format. If the server returns data that is not compatible with the <code>responseType</code> that was set, the value of {{domxref("XMLHttpRequest.response", "response")}} will be <code>null</code>.</p>
</div>

<p>The values supported by <code>responseType</code> are the following:</p>

<p>{{page("/en-US/docs/Web/API/XMLHttpRequestResponseType", "Values")}}</p>

<h3 id="Exceptions">Exceptions</h3>

<dl>
 <dt><code>InvalidAccessError</code></dt>
 <dd>An attempt was made to change the value of <code>responseType</code> on an<code>XMLHttpRequest</code> which is in synchronous mode but not in a {{domxref("Worker")}}. For additional details, see {{anch("Synchronous XHR restrictions")}} below.</dd>
</dl>

<h2 id="Usage_notes">Usage notes</h2>

<h3 id="Synchronous_XHR_restrictions">Synchronous XHR restrictions</h3>

<p>You cannot change the value of <code>responseType</code> in a synchronous <code>XMLHttpRequest</code> except when the request belongs to a {{domxref("Worker")}}. This restriction is designed in part to help ensure that synchronous operations aren't used for large transactions that block the browser's main thread, thereby bogging down the user experience.</p>

<p><code>XMLHttpRequest</code>s are asynchronous by default; they are only placed in synchronous mode by passing <code>false</code> as the value of the optional <code>async</code> parameter when calling {{domxref("XMLHttpRequest.open", "open()")}}.</p>

<h3 id="Restrictions_in_Workers">Restrictions in Workers</h3>

<p>Attempts to set the value of <code>responseType</code> to <code>document</code> are ignored in a {{domxref("Worker")}}.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('XMLHttpRequest', '#the-responsetype-attribute')}}</td>
   <td>{{Spec2('XMLHttpRequest')}}</td>
   <td>WHATWG living standard</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.XMLHttpRequest.responseType")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/XMLHttpRequest/Using_XMLHttpRequest">Using XMLHttpRequest</a></li>
 <li><a href="/en-US/docs/Web/API/XMLHttpRequest/HTML_in_XMLHttpRequest">HTML in XMLHttpRequest</a></li>
 <li>The response data: {{domxref("XMLHttpRequest.response", "response")}}, {{domxref("XMLHttpRequest.responseText", "responseText")}}, and {{domxref("XMLHttpRequest.responseXML", "responseXML")}}</li>
</ul>
